#ifndef NB_BIOMETRICS_TEMPLATE_HPP
#define NB_BIOMETRICS_TEMPLATE_HPP

#include <NBBiometricsTypes.hpp>
#include <vector>

namespace NextBiometrics
{
    namespace Biometrics
    {
        #include <NBBiometricsTemplate.h>

        class NBBiometricsTemplate
        {
            friend class NBBiometricsExtractResult;
            friend class NBBiometricsCreateEnrollTemplateResult;
            friend class NBBiometricsContext;

            vector<NBByte> m_pData;

            NBBiometricsTemplate(const NBByte * pData, NBSizeType stDataSize, NBSizeType stActualSize)
            {
                if (pData && stActualSize > 0)
                {
                    m_pData.assign(pData, pData + stActualSize);
                }
            }
        public:
            NBBiometricsTemplate()
                : NBBiometricsTemplate(nullptr, 0, 0)
            {
            }

            NBBiometricsFingerPosition GetPosition() const
            {
                NBBiometricsFingerPosition eValue;
                NBErrors::RequireNoErr(NBBiometricsTemplateGetPosition(m_pData.data(), m_pData.size(), &eValue));
                return eValue;
            }

            NBBiometricsTemplateType GetType() const
            {
                NBBiometricsTemplateType eValue;
                NBErrors::RequireNoErr(NBBiometricsTemplateGetType(m_pData.data(), m_pData.size(), &eValue));
                return eValue;
            }
        };
    }
}

#endif // !NB_BIOMETRICS_TEMPLATE_HPP
