﻿using System;
using System.Windows.Forms;
using NBBiometricsSampleCS.Misc;
using NextBiometrics.Devices;

namespace NBBiometricsSampleCS.Forms
{
    public partial class ConnectToSpiForm : Form
    {
        #region Private fields

        private DeviceInfo _device;

        #endregion

        #region Public constructor

        public ConnectToSpiForm()
        {
            InitializeComponent();
        }

        #endregion

        #region Public properties

        public string SpiName
        {
            get { return textBoxSpiName.Text; }
            set { textBoxSpiName.Text = value; }
        }

        public int AwakePin
        {
            get { return (int) numericUpDownAwakePin.Value; }
            set { numericUpDownAwakePin.Value = value; }
        }

        public int ResetPin
        {
            get { return (int) numericUpDownResetPin.Value; }
            set { numericUpDownResetPin.Value = value; }
        }

        public int ChipSelectPin
        {
            get { return (int) numericUpDownChipSelectPin.Value; }
            set { numericUpDownChipSelectPin.Value = value; }
        }

        public DeviceInfo Device
        {
            get { return _device; }
        }

        #endregion

        #region Private form events

        private void ConnectToSpiForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = false;
            if (DialogResult == DialogResult.Cancel)
            {
                return;
            }
            try
            {
                _device = new DeviceInfo(true, NBDevice.ConnectToSpi(SpiName, AwakePin, ResetPin, ChipSelectPin));
            }
            catch (Exception ex)
            {
                e.Cancel = true;
                MessageBox.Show(string.Format("Failed to connect to SPI. Reason: {0}", ex.Message), Text,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        #endregion
    }
}
