﻿using NextBiometrics.Biometrics;

namespace NBBiometricsSampleCS.Misc
{
    public class BiometricInfo
    {
        private NBBiometricsStatus _status;
        private NBBiometricsTemplate _template;
        private int _score;
        private object _templateId;

        public NBBiometricsStatus Status
        {
            get { return _status; }
        }

        public NBBiometricsTemplate Template
        {
            get { return _template; }
        }

        public int Score
        {
            get { return _score; }
        }

        public object TemplateId
        {
            get { return _templateId; }
        }

        private BiometricInfo(NBBiometricsStatus status, NBBiometricsTemplate template, int score, object templateId)
        {
            _status = status;
            _template = template;
            _score = score;
            _templateId = templateId;
        }

        public BiometricInfo(NBBiometricsCreateEnrollTemplateResult result)
            : this(result.Status, result.Template, 0, null)
        {
        }

        public BiometricInfo(NBBiometricsExtractResult result)
            : this(result.Status, result.Template, 0, null)
        {
        }

        public BiometricInfo(NBBiometricsVerifyResult result)
            : this(result.Status, null, result.Score, null)
        {
        }

        public BiometricInfo(NBBiometricsIdentifyResult result)
            : this(result.Status, null, result.Score, result.TemplateId)
        {
        }
    }
}
