﻿using System.Collections.Generic;
using NextBiometrics.Devices;

namespace NBBiometricsSampleCS.Misc
{
    public class DeviceInfo
    {
        private bool _isSpi;
        private NBDevice _device;

        public bool IsSpi
        {
            get { return _isSpi; }
            set { _isSpi = value; }
        }

        public NBDevice Device
        {
            get { return _device; }
            set { _device = value; }
        }

        public DeviceInfo(bool isSpi, NBDevice device)
        {
            IsSpi = isSpi;
            Device = device;
        }

        public override string ToString()
        {
            return string.Format("{0}: {1}", IsSpi ? "SPI" : "USB", Device);
        }

        public override bool Equals(object obj)
        {
            var info = obj as DeviceInfo;
            return info != null &&
                   IsSpi == info.IsSpi &&
                   EqualityComparer<NBDevice>.Default.Equals(Device, info.Device);
        }

        public override int GetHashCode()
        {
            var hashCode = 612518936;
            hashCode = hashCode * -1521134295 + IsSpi.GetHashCode();
            hashCode = hashCode * -1521134295 + EqualityComparer<NBDevice>.Default.GetHashCode(Device);
            return hashCode;
        }
    }
}
