﻿using NextBiometrics.Biometrics;
using NextBiometrics.Devices;

namespace NBBiometricsSampleCS.Misc
{
    public class PreviewInfo
    {
        private NBDeviceScanStatus _status;
        private NBDeviceScanFormatInfo _format;
        private byte[] _image;
        private int _fingerDetectValue;

        public NBDeviceScanStatus Status
        {
            get { return _status; }
        }

        public NBDeviceScanFormatInfo Format
        {
            get { return _format; }
        }

        public byte[] Image
        {
            get { return _image; }
        }

        public int FingerDetectValue
        {
            get { return _fingerDetectValue; }
        }

        private PreviewInfo(NBDeviceScanStatus status, NBDeviceScanFormatInfo format, byte[] image,
            int fingerDetectValue)
        {
            _status = status;
            _format = format;
            _image = image;
            _fingerDetectValue = fingerDetectValue;
        }

        public PreviewInfo(NBDeviceScanResult result, int fingerDetectValue)
            : this(result.Status, result.Format, result.Image, fingerDetectValue)
        {
        }

        public PreviewInfo(NBDeviceScanPreviewEventArgs args)
            : this(args.Status, args.Format, args.Image, args.FingerDetectValue)
        {
        }

        public PreviewInfo(NBBiometricsScanPreviewEventArgs args)
            : this(args.ScanStatus, args.Format, args.Image, args.FingerDetectValue)
        {
        }
    }
}
