﻿using System;
using System.Security.Principal;
using System.Windows.Forms;
using NBBiometricsSampleCS.Forms;

namespace NBBiometricsSampleCS
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            if (Environment.OSVersion.Platform != PlatformID.Unix && Environment.OSVersion.Platform != PlatformID.MacOSX)
            {
                WindowsPrincipal principal = new WindowsPrincipal(WindowsIdentity.GetCurrent());
                if (!principal.IsInRole(WindowsBuiltInRole.Administrator))
                {
                    MessageBox.Show(
                        "Sample application might require administrative privileges. If sensor is connected, but not detected - try restarting application" +
                        " in administrator mode (Run As Administrator).", "NEXT Biometrics", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new MainForm());
        }
    }
}
